From 19feb5a34b9d79d4052b4ad5b499e3d19bc328b3 Mon Sep 17 00:00:00 2001
From: Robert Haas <rhaas@postgresql.org>
Date: Mon, 2 Dec 2019 11:53:25 -0500
Subject: [PATCH v2 5/5] Not for commit: test code.

---
 src/backend/storage/ipc/signalfuncs.c | 11 +++++++++++
 src/include/catalog/pg_proc.dat       |  5 +++++
 2 files changed, 16 insertions(+)

diff --git a/src/backend/storage/ipc/signalfuncs.c b/src/backend/storage/ipc/signalfuncs.c
index ade8d713aa..f6deebcb5a 100644
--- a/src/backend/storage/ipc/signalfuncs.c
+++ b/src/backend/storage/ipc/signalfuncs.c
@@ -215,3 +215,14 @@ pg_rotate_logfile_v2(PG_FUNCTION_ARGS)
 	SendPostmasterSignal(PMSIGNAL_ROTATE_LOGFILE);
 	PG_RETURN_BOOL(true);
 }
+
+Datum
+sample_barrier(PG_FUNCTION_ARGS)
+{
+	uint64	bgen;
+
+	bgen = EmitProcSignalBarrier(PROCSIGNAL_BARRIER_SAMPLE);
+	elog(NOTICE, "emitted barrier");
+	WaitForProcSignalBarrier(bgen);
+	PG_RETURN_VOID();
+}
diff --git a/src/include/catalog/pg_proc.dat b/src/include/catalog/pg_proc.dat
index ac8f64b219..380bdfea45 100644
--- a/src/include/catalog/pg_proc.dat
+++ b/src/include/catalog/pg_proc.dat
@@ -10729,4 +10729,9 @@
   proname => 'pg_partition_root', prorettype => 'regclass',
   proargtypes => 'regclass', prosrc => 'pg_partition_root' },
 
+# function to get the top-most partition root parent
+{ oid => '9758', descr => 'send sample barrier',
+  proname => 'sample_barrier', prorettype => 'void',
+  proargtypes => '', prosrc => 'sample_barrier' },
+
 ]
-- 
2.17.2 (Apple Git-113)

